JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | List of all members
juce::dsp::FFT Class Reference
juce_dsp » frequency

Performs a fast fourier transform. More...

`#include <juce_FFT.h>`

## Public Member Functions
| FFT (int order)
| Initialises an object for performing forward and inverse FFT with the given size.
| FFT (FFT &&) noexcept
| Move constructor.
FFT & | operator= (FFT &&) noexcept
| Move assignment operator.
| ~FFT ()
| Destructor.
void | perform (const Complex< float > *input, Complex< float > *output, bool inverse) const noexcept
| Performs an out-of-place FFT, either forward or inverse.
void | performRealOnlyForwardTransform (float *inputOutputData, bool onlyCalculateNonNegativeFrequencies=false) const noexcept
| Performs an in-place forward transform on a block of real data.
void | performRealOnlyInverseTransform (float *inputOutputData) const noexcept
| Performs a reverse operation to data created in performRealOnlyForwardTransform().
void | performFrequencyOnlyForwardTransform (float *inputOutputData, bool onlyCalculateNonNegativeFrequencies=false) const noexcept
| Takes an array and simply transforms it to the magnitude frequency response spectrum.
int | getSize () const noexcept
| Returns the number of data points that this FFT was created to work with.

## Detailed Description

Performs a fast fourier transform.

This is only a simple low-footprint implementation and isn't tuned for speed - it may be useful for simple applications where one of the more complex FFT libraries would be overkill. (But in the future it may end up becoming optimised of course...)

The FFT class itself contains lookup tables, so there's some overhead in creating one, you should create and cache an FFT object for each size/direction of transform that you need, and re-use them to perform the actual operation.

## Constructor & Destructor Documentation

## ◆ FFT() [1/2]

juce::dsp::FFT::FFT | ( | int | order | ) |

Initialises an object for performing forward and inverse FFT with the given size.

The number of points the FFT will operate on will be 2 ^ order.

## ◆ FFT() [2/2]

juce::dsp::FFT::FFT | ( | FFT && |  | ) |
| noexcept

Move constructor.

## ◆ ~FFT()

juce::dsp::FFT::~FFT | ( |  | ) |

Destructor.

## Member Function Documentation

## ◆ operator=()

FFT & juce::dsp::FFT::operator= | ( | FFT && |  | ) |
| noexcept

Move assignment operator.

## ◆ perform()

void juce::dsp::FFT::perform | ( | const Complex< float > * | input,
|  | Complex< float > * | output,
|  | bool | inverse ) const
| noexcept

Performs an out-of-place FFT, either forward or inverse.

The arrays must contain at least getSize() elements.

## ◆ performRealOnlyForwardTransform()

void juce::dsp::FFT::performRealOnlyForwardTransform | ( | float * | inputOutputData,
|  | bool | onlyCalculateNonNegativeFrequencies = false ) const
| noexcept

Performs an in-place forward transform on a block of real data.

As the coefficients of the negative frequencies (frequencies higher than N/2 or pi) are the complex conjugate of their positive counterparts, it may not be necessary to calculate them for your particular application. You can use onlyCalculateNonNegativeFrequencies to let the FFT engine know that you do not plan on using them. Note that this is only a hint: some FFT engines (currently only the Fallback engine), will still calculate the negative frequencies even if onlyCalculateNonNegativeFrequencies is true.

The size of the array passed in must be 2 * getSize(), and the first half should contain your raw input sample data. On return, if onlyCalculateNonNegativeFrequencies is false, the array will contain size complex real + imaginary parts data interleaved. If onlyCalculateNonNegativeFrequencies is true, the array will contain at least (size / 2) + 1 complex numbers. Both outputs can be passed to performRealOnlyInverseTransform() in order to convert it back to reals.

## ◆ performRealOnlyInverseTransform()

void juce::dsp::FFT::performRealOnlyInverseTransform | ( | float * | inputOutputData | ) | const
| noexcept

Performs a reverse operation to data created in performRealOnlyForwardTransform().

Although performRealOnlyInverseTransform will only use the first ((size / 2) + 1) complex numbers, the size of the array passed in must still be 2 * getSize(), as some FFT engines require the extra space for the calculation. On return, the first half of the array will contain the reconstituted samples.

## ◆ performFrequencyOnlyForwardTransform()

void juce::dsp::FFT::performFrequencyOnlyForwardTransform | ( | float * | inputOutputData,
|  | bool | onlyCalculateNonNegativeFrequencies = false ) const
| noexcept

Takes an array and simply transforms it to the magnitude frequency response spectrum.

This may be handy for things like frequency displays or analysis. The size of the array passed in must be 2 * getSize().

On return, if onlyCalculateNonNegativeFrequencies is false, the array will contain size magnitude values. If onlyCalculateNonNegativeFrequencies is true, the array will contain at least size / 2 + 1 magnitude values.

## ◆ getSize()

int juce::dsp::FFT::getSize | ( |  | ) | const
| noexcept

Returns the number of data points that this FFT was created to work with.

The documentation for this class was generated from the following file:

- juce_FFT.h